
#include <stdio.h>
#include <stdlib.h>
#include <i86.h>
#include <conio.h>
#include <sys/osinfo.h>

extern int micro_time( unsigned long * );



void main(int argc, char *argv[]){

int	i = 23000;
int c;
int verbose = 0;
unsigned long *tptr1;
unsigned long *temp1;
struct _timesel far *os_tptr;
unsigned long start_sec, start_nsec;
unsigned long end_sec, end_nsec;

if (argc > 1)
	i = atoi( argv[1] );

if (argc > 2)
	verbose++;

os_tptr = MK_FP( 0xb0, 0 );

tptr1 = malloc( i * 2 * sizeof (unsigned long) );
if (tptr1 == NULL ){
	printf("Couldn't get %d bytes of memory!\n", i * 2 * sizeof( unsigned long ));
	return;
	}
temp1 = tptr1;

_disable();
start_sec = os_tptr->seconds;
start_nsec = os_tptr->nsec;
_enable();

for ( c = 0; c < i; c++, temp1 += 2 ){
	micro_time( temp1 ); 
	}

_disable();
end_sec = os_tptr->seconds;
end_nsec = os_tptr->nsec;
_enable();

if (verbose){
	temp1 = tptr1;
	printf("     Seconds             Nano-Seconds\n");
	for ( c = 0; c < i; c++, temp1 += 2 )
		printf("%12lu        %12lu\n", *temp1, *(temp1+1) );
	}

printf("\n\nIterations: %d\nStart Time: %12lu %12lu\nEnd Time:   %12lu %12lu\n",
		i, *tptr1, *(tptr1+1), *(temp1-2), *(temp1-1) );
printf("\n\nOS Time:\nStart Time: %12lu %12lu\nEnd Time:   %12lu %12lu\n", 
		start_sec, start_nsec, end_sec, end_nsec);

}
